package com.example.kafkaproducerconsume.service;

import com.example.kafkaproducerconsume.KafkaproducerconsumeApplication;
import com.example.kafkaproducerconsume.entity.KafkaEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;

@Service
public class Consumer {

    Logger logger = LoggerFactory.getLogger(KafkaproducerconsumeApplication.class);


    public static final String consumedTopic = "mytopic6";
    public static final String publishedTopic = "mytopic7";

    private final KafkaService kafkaService;
    private final KafkaTemplate<String, KafkaEntity> kafkaTemplate;

    @Autowired
    public Consumer(KafkaService kafkaService, KafkaTemplate<String, KafkaEntity> kafkaTemplate) {
        this.kafkaService = kafkaService;
        this.kafkaTemplate = kafkaTemplate;
    }

    @KafkaListener(topics = {consumedTopic}, groupId = "mygroup")
    public void consumeFromTopic(KafkaEntity message) {
       logger.info("Consumed message: " + message.getMessage());
        kafkaService.save(message);
        publishToTopic(message);
    }

    private void publishToTopic(KafkaEntity message) {
        logger.info("Publishing to topic: " + publishedTopic);
        this.kafkaTemplate.send(publishedTopic, message);
    }
}
