package com.example.kafkaproducerconsume.service;

import com.example.kafkaproducerconsume.KafkaproducerconsumeApplication;
import com.example.kafkaproducerconsume.entity.KafkaEntity;
import com.fasterxml.jackson.core.JsonProcessingException;

import com.fasterxml.jackson.databind.ObjectMapper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;

@Service
public class Producer {

    Logger logger = LoggerFactory.getLogger(KafkaproducerconsumeApplication.class);

    public static final String topic1 = "mytopic6";
    public static final String topic2 = "mytopic7";

    private final KafkaService kafkaService;
    private final KafkaTemplate<String, String> kafkaTemplate;
    private final ObjectMapper objectMapper;

    @Autowired
    public Producer(KafkaService kafkaService, KafkaTemplate<String, String> kafkaTemplate, ObjectMapper objectMapper) {
        this.kafkaService = kafkaService;
        this.kafkaTemplate = kafkaTemplate;
        this.objectMapper = objectMapper;
    }

    public void publishToTopic(KafkaEntity message) throws JsonProcessingException {
        logger.info("Publishing to topic: " + topic1);
        String jsonMessage = objectMapper.writeValueAsString(message);
        this.kafkaTemplate.send(topic1, jsonMessage);
    }

    public void publish1(KafkaEntity message1) throws JsonProcessingException {
        kafkaService.save(message1);
        logger.info("Publishing to topic: " + topic2);
        String jsonMessage = objectMapper.writeValueAsString(message1);
        this.kafkaTemplate.send(topic2, jsonMessage);
    }

    public void publish2(Integer id) throws JsonProcessingException {
        KafkaEntity entity = kafkaService.get(id);
        if (entity != null) {
           logger.info("Publishing to topic: " + topic2);
            String jsonMessage = objectMapper.writeValueAsString(entity);
            this.kafkaTemplate.send(topic2, jsonMessage);
        }
    }
}
